Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 33 by niro, Thu Jan 6 02:57:12 2005 UTC revision 194 by niro, Sat Aug 20 15:32:59 2005 UTC
# Line 4  Line 4 
4  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
5    
6  # SMAGE2  # SMAGE2
7  # version: 0.3.6-r9  # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.25 2005-08-20 15:32:59 niro Exp $
8    
9  #01.10.2004  #01.10.2004
10  # added ccache support  # added ccache support
11  # added distcc support  # added distcc support
12    
13  ## setup ##  ## setup ##
 SMAGEVERSION=0.3.6-r8  
14  PKGSUFFIX="mpk"  PKGSUFFIX="mpk"
15  SMAGENAME="$1"  SMAGENAME="$1"
16  SMAGESUFFIX="smage2"  SMAGESUFFIX="smage2"
# Line 19  SMAGESUFFIX="smage2" Line 18  SMAGESUFFIX="smage2"
18  #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"
19  #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"
20  MLIBDIR=/usr/lib/mage  MLIBDIR=/usr/lib/mage
21    SMAGEVERSION="$( < ${MLIBDIR}/version)"
22    
23    # export default C locale
24    export LC_ALL=C
25    
26  source /etc/mage.rc  source /etc/mage.rc
27    
# Line 84  syncsmage2() { Line 87  syncsmage2() {
87   xtitleclean   xtitleclean
88  }  }
89    
90    # $1 filename
91    get_db_md5_sum() {
92     local DB_FILE
93     local MD5_FILE
94     local i
95    
96     DB_ENTRY="$(basename $1)"
97     MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"
98    
99     i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"
100    
101     echo "${i}"
102    }
103    
104    download_sources() {
105    
106     [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0
107    
108     local EOA=${#SRC_URI[*]}
109     local my_SRC_URI
110     local my_SRC_URI_DEST
111     local my_SRC_URI_MIRROR
112     local my_SOURCEDIR
113     local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
114     local FETCHING
115     local i mirror
116    
117    
118     #install SRCDIR/PNAME if not exist
119     [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}
120    
121     # check if FETCHING is needed
122     ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )
123     if [[ $? == 0 ]]
124     then
125     # md5's ok, not fetching needed
126     FETCHING=false
127     else
128     FETCHING=true
129     fi
130    
131     for ((i=0; i < EOA; i++))
132     do
133     # url to file
134     my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"
135    
136     # subdir in sources dir; the my_SRCI_URI file goes to there
137     my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"
138    
139     # if my_src_uri_dest is not equal my_src_uri; than an other dir is used
140     if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]
141     then
142     my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"
143     else
144     my_SOURCEDIR="${SOURCEDIR}/${PNAME}"
145     fi
146    
147     # if an mirrored file than replace first the mirror uri
148     if [ -n "$(echo ${my_SRC_URI} | grep 'mirror://')" ]
149     then
150     for mirror in ${MIRRORS}
151     do
152     my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"
153    
154     #echo "DEBUG: ${MY_SRC_URI}"
155     if [[ ${FETCHING} == true ]]
156     then
157     echo "==> fetching ${my_SRC_URI_MIRROR}"
158     wget \
159     --passive-ftp \
160     --tries 3 \
161     --continue \
162     --progress bar \
163     --directory-prefix="${my_SOURCEDIR}" \
164     "${my_SRC_URI_MIRROR}"
165     if [ "$?" == "0" ]
166     then
167     break
168     else
169     continue
170     fi
171     fi
172     done
173     else
174     #echo "DEBUG: ${SRC_URI[${i}]}"
175     if [[ ${FETCHING} == true ]]
176     then
177     echo "==> fetching ${my_SRC_URI}"
178     wget \
179     --passive-ftp \
180     --tries 3 \
181     --continue \
182     --progress bar \
183     --directory-prefix="${my_SOURCEDIR}" \
184     "${my_SRC_URI}"
185    # only needed to run through a list of mirrors
186    # if [ "$?" == "0" ]
187    # then
188    # break
189    # else
190    # continue
191    # fi
192     fi
193     fi
194    
195     # unset them to be shure
196     unset my_SRC_URI
197     unset my_SRC_URI_DEST
198     unset my_SRC_URI_MIRROR
199     unset my_SOURCEDIR
200     done
201    
202     # recheck md5 sums
203     echo
204     echo ">== Checking MD5 sums:"
205     ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"
206     echo
207    
208     # not needed anymore
209     unset SRC_URI
210    }
211    
212  # dummy function, used if that not exist in smage file  # dummy function, used if that not exist in smage file
213  src_prepare() {  src_prepare() {
214   echo "no src_prepare defined"   echo "no src_prepare defined"
# Line 105  src_install() { Line 230  src_install() {
230   return 0   return 0
231  }  }
232    
   
 build_mage_script() {  
  return 0  
 }  
   
233  mconfigure() {  mconfigure() {
234   if [ -x ./configure ]   if [ -x ./configure ]
235   then   then
# Line 218  minstalldocs() { Line 338  minstalldocs() {
338   done   done
339  }  }
340    
341    mstriplibs() {
342     local stripdir="$@"
343    
344     [ -z "${stripdir}" ] && stripdir=${BINDIR}
345     find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
346    }
347    
348    mstripbins() {
349     local stripdir="$@"
350    
351     [ -z "${stripdir}" ] && stripdir=${BINDIR}
352     find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
353    }
354    
355    sminclude() {
356     local i
357    
358     if [[ -n "$@" ]]
359     then
360     for i in $@
361     do
362     echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"
363     source ${SMAGESCRIPTSDIR}/include/${i}.sminc
364     done
365     echo
366     fi
367    }
368    
369  setup_distcc_environment(){  setup_distcc_environment(){
370   if [ -x /usr/bin/distcc ]   if [ -x /usr/bin/distcc ]
371   then   then
# Line 258  setup_ccache_environment(){ Line 406  setup_ccache_environment(){
406   fi   fi
407  }  }
408    
409    
410    # fixes given dependencies to match a MAGE_TARGET
411    # fix_mage_deps -target s/depend # <-- '-' is essential ! (build_mage_script needs this)
412    fix_mage_deps() {
413     local target="$1"
414     local depend="$2"
415     local NDEPEND
416     local sym dep cat pver pname
417    
418     # deps and provides are special
419     # they must be fixed to match the target
420    
421     # run this only if target and depend is not empty
422     if [ -n "${target}" ] && [ -n "${depend}" ]
423     then
424     # fix DEPEND
425     while read sym dep
426     do
427     cat="$(dirname ${dep})"
428     # abort on virtual
429     [[ ${cat} = virtual ]] && continue
430    
431     # fix pver to target-pver
432     # to get pname-target-pver
433    
434     # doing it backwards !
435     pver="${dep##*-}"
436     pname=$(basename ${dep/-${pver}/})
437    
438     # do not add empty lines
439     if [ -z "${NDEPEND}" ]
440     then
441     NDEPEND="${sym} ${cat}/${pname}${target}-${pver}"
442     else
443     NDEPEND="${NDEPEND}
444     ${sym} ${cat}/${pname}${target}-${pver}"
445     fi
446    
447     unset cat pname pver
448     done << EOF
449    ${depend}
450    EOF
451     # set NDEPEND to DEPEND
452     depend="${NDEPEND}"
453     fi
454    
455     echo "${depend}"
456    }
457    
458    # build_mage_script(): helper functions for regen_mage_tree()
459    # generates an mage file with given information in smage file
460    # needs at least:
461    #   PNAME                 name of pkg
462    #   PVER                  version
463    #   PBUILD                revision
464    #   PCATEGORIE            categorie of the pkg
465    #   STATE                 state of pkg stable|unstable|old
466    #   DESCRIPTION           va short description (opt)
467    #   HOMEPAGE              homepage (opt)
468    #   DEPEND                runtime dependencies (opt)
469    #   SDEPEND               add. needed deps to build the pkg (opt)
470    #   PROVIDE               provides a virtual (opt)
471    #
472    # special tags:
473    #   PKGTYPE               type of pkg
474    #   INHERITS              which functions get included
475    #   SPECIAL_FUNCTIONS     special functions wich should also be added
476    #                         warning: they get killed before the build starts !
477    #
478    #   MAGE_TREE_DEST        target destination of the generated tree
479    #   REGEN_MAGE_TREE       set to 'true' to enable this
480    #
481    # gets called with build_mage_script target # <-- '-' is essential !
482    build_mage_script()
483    {
484     local magefile
485     local dest
486     local target
487     local sym
488     local depname
489    
490     # if MAGE_TREE_DEST not set use BUILDDIR
491     : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
492    
493     # determinate which suffix this mage file should get, if any
494     target="$1"
495    
496     # name of magefile
497     magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"
498    
499     # destination to magefile
500     dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"
501    
502     # show what we are doing
503     echo "Generating Mage file:"
504     echo "  ${dest}"
505    
506     install -d "$(dirname ${dest})"
507     # now build the mage file
508     > ${dest}
509    
510     # header
511     echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.25 2005-08-20 15:32:59 niro Exp $' >> ${dest}
512     echo  >> ${dest}
513    
514     # pgkname and state
515     echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}
516     echo "STATE=\"${STATE}\"" >> ${dest}
517     echo >> ${dest}
518    
519     # description and homepage
520     echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}
521     echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}
522     echo >> ${dest}
523    
524     # special tags
525     echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}
526     if [ -n "${INHERITS}" ]
527     then
528     echo -n "minclude"  >> ${dest}
529     local i
530     for i in ${INHERITS}
531     do
532     echo -n " ${i}"  >> ${dest}
533     done
534     echo  >> ${dest}
535     fi
536     echo >> ${dest}
537    
538     # deps and provides
539     echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}
540     echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}
541     echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
542     echo >> ${dest}
543    
544     # add special functions
545     if [ -n "${SPECIAL_FUNCTIONS}" ]
546     then
547     local i
548     for i in ${SPECIAL_FUNCTIONS}
549     do
550     # add to mage (quotes needed !)
551     typeset -f "${i}" >> ${dest}
552     # unset to be safe (quotes needed !)
553     #unset "${i}" <-- later to get every target built
554     done
555     fi
556    
557     # add special vars
558     if [ -n "${SPECIAL_VARS}" ]
559     then
560     local i
561     for i in ${SPECIAL_VARS}
562     do
563     # being tricky here :)
564     echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}
565     done
566     fi
567    
568     # pre|post-install|removes
569     typeset -f preinstall >> ${dest}
570     echo  >> ${dest}
571     typeset -f postinstall >> ${dest}
572     echo  >> ${dest}
573     typeset -f preremove >> ${dest}
574     echo  >> ${dest}
575     typeset -f postremove >> ${dest}
576     echo  >> ${dest}
577    }
578    
579    regen_mage_tree()
580    {
581     local i
582    
583     # build them only if requested
584     if [[ ${REGEN_MAGE_TREE} = true ]]
585     then
586     # build for each target an mage file
587     for i in ${MAGE_TARGETS}
588     do
589     echo
590     build_mage_script "-${i}"
591     echo
592     done
593     fi
594    
595     # now unset all uneeded vars to be safe
596     # unset PKGNAME <-- don't do that; smage needs this var
597     # unset to be safe (quotes needed !)
598     for i in ${SPECIAL_FUNCTIONS}
599     do
600     unset "${i}"
601     done
602     unset SPECIAL_FUNCTIONS
603     for i in ${SPECIAL_VARS}
604     do
605     unset "${i}"
606     done
607     unset SPECIAL_VARS
608     unset STATE
609     unset DESCRIPTION
610     unset HOMEPAGE
611     unset PKGTYPE
612     unset INHERITS
613     unset DEPEND
614     unset SDEPEND
615     unset PROVIDE
616     unset preinstall
617     unset postinstall
618     unset preremove
619     unset postremove
620    }
621    
622    # print out our version
623    showversion
624    echo
625    
626  if [ -z "$1" ]  if [ -z "$1" ]
627  then  then
  showversion  
  echo  
628   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
629   echo   echo
630   exit 1   exit 1
631  fi  fi
632    
633  #updating smage2-scripts  # updating smage2-scripts
634  if [ "$1" == "update" ]  if [ "$1" == "update" ]
635  then  then
636   showversion   if [ ! -d ${SOURCEDIR} ]
  if [ ! -d ${SMAGESCRIPTSDIR} ]  
637   then   then
638   install -d ${SMAGESCRIPTSDIR}   install -d ${SOURCEDIR}
639   fi   fi
640   syncsmage2   syncsmage2
641   exit 0   exit 0
642  fi  fi
643    
644    # creates md5sums for smages to given dir
645    if [ "$1" == "calcmd5" ]
646    then
647     if [ $# -ge 3 ]
648     then
649     SMAGENAME="$2"
650     MD5DIR="$3"
651     source ${SMAGENAME} || die "download source failed"
652    
653     # overridable sourcedir; must be declared after source of the smage2
654     CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
655    
656     [ -z "${SRC_URI}" ] && die "Nothing declared to calculate."
657    
658     # end of array
659     EOA=${#SRC_URI[*]}
660    
661     [ ! -d ${MD5DIR} ] && install -d ${MD5DIR}
662    
663     # clear md5sum file
664     MY_MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
665     echo -n > ${MY_MD5_FILE}
666    
667     for ((i=0; i < EOA; i++))
668     do
669     # url to file
670     my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"
671    
672     # subdir in sources dir; the my_SRCI_URI file goes to there
673     my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"
674    
675     # if my_src_uri_dest is not equal my_src_uri; than an other dir is used
676     if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]
677     then
678     MY_SRC_FILE="${my_SRC_URI_DEST}/$(basename ${SRC_URI[${i}]})"
679     else
680     MY_SRC_FILE="$(basename ${SRC_URI[${i}]})"
681     fi
682    
683     if [ -e "${CALC_SOURCEDIR}/${MY_SRC_FILE}" ]
684     then
685     echo "calculating $(basename ${MY_SRC_FILE}) ..."
686     ( cd ${CALC_SOURCEDIR}; md5sum "${MY_SRC_FILE}" ) >> ${MY_MD5_FILE}
687     else
688     echo "WARNING: File '$(basename ${MY_SRC_FILE}) not found in ${CALC_SOURCEDIR}."
689     fi
690    
691     # unset them to be shure
692     unset my_SRC_URI
693     unset my_SRC_URI_DEST
694     unset my_SRC_URI_MIRROR
695     unset my_SOURCEDIR
696     done
697    
698     echo
699     echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
700     echo
701     else
702     echo "Usage: Calculating MD5 Sums:"
703     echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"
704     echo
705     echo
706     echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
707     echo
708     exit 1
709     fi
710    
711     exit 0
712    fi
713    
714    # download sources
715    if [ "$1" == "download" -a -n "$2" ]
716    then
717     if [ ! -d ${SMAGESCRIPTSDIR} ]
718     then
719     install -d ${SMAGESCRIPTSDIR}
720     fi
721    
722     # get smage
723     SMAGENAME="$2"
724     MD5DIR="$(dirname ${SMAGENAME})/md5"
725     source ${SMAGENAME} || die "download source failed"
726    
727     download_sources
728     exit 0
729    fi
730    
731  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]
732  then  then
# Line 329  fi Line 777  fi
777    
778  source ${SMAGENAME} || die "source failed"  source ${SMAGENAME} || die "source failed"
779  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"
780    MD5DIR="$(dirname ${SMAGENAME})/md5"
781    
782  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
783  #fixes some issues with these functions  echo "Compiling ${PKGNAME}"
784    
785    # auto regen mage tree if requested
786    regen_mage_tree
787    
788    # download sources
789    download_sources
790    
791    # fixes some issues with these functions
792  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
793  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
794  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
795    
796  #fixes some compile issues  # fixes some compile issues
797  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
798  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
799  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
# Line 344  export BINDIR="${BINDIR}" || die "BINDIR Line 801  export BINDIR="${BINDIR}" || die "BINDIR
801  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
802    
803    
804  #setup distcc  # setup distcc
805  #distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # distcc mus be setup *before* ccache, as ccache need to be before distcc in path
806  if [ "${SMAGE_USE_DISTCC}" == "true" ]  if [ "${SMAGE_USE_DISTCC}" == "true" ]
807  then  then
808   setup_distcc_environment   setup_distcc_environment
809  fi  fi
810    
811  #setup ccache  # setup ccache
812  if [ "${SMAGE_USE_CCACHE}" == "true" ]  if [ "${SMAGE_USE_CCACHE}" == "true" ]
813  then  then
814   setup_ccache_environment   setup_ccache_environment
# Line 372  sleep 1 Line 829  sleep 1
829  #read  #read
830  #debug end  #debug end
831    
832  #cleans up build if a previously one exists  # cleans up build if a previously one exists
833  if [ -d ${BUILDDIR} ]  if [ -d ${BUILDDIR} ]
834  then  then
835   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
836  fi  fi
837  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
838    
839  #cleans up srcdir if a previously unpacked one exists  # cleans up srcdir if a previously unpacked one exists
840  if [ -d ${SRCDIR} ]  if [ -d ${SRCDIR} ]
841  then  then
842   rm -rf ${SRCDIR}   rm -rf ${SRCDIR}
843  fi  fi
844    
845  #cleans up bindir if a previous build exists or creates a new one  # cleans up bindir if a previous build exists or creates a new one
846  if [ -d ${BINDIR} ]  if [ -d ${BINDIR} ]
847  then  then
848   rm -rf ${BINDIR}   rm -rf ${BINDIR}
849  fi  fi
850  install -d ${BINDIR} || die "couldn't create \$BINDIR."  install -d ${BINDIR} || die "couldn't create \$BINDIR."
851    
852  #cleans up package temp dir if a previous build exists  # cleans up package temp dir if a previous build exists
853  if [ -d ${BUILDDIR}/${PKGNAME} ]  if [ -d ${BUILDDIR}/${PKGNAME} ]
854  then  then
855   rm -rf ${BUILDDIR}/${PKGNAME}   rm -rf ${BUILDDIR}/${PKGNAME}
856  fi  fi
857    
858  #cleans up timestamp if one exists  # cleans up timestamp if one exists
859  if [ -f /var/tmp/timestamp ]  if [ -f /var/tmp/timestamp ]
860  then  then
861   mage rmstamp   mage rmstamp
# Line 409  src_compile || die "src_compile failed" Line 866  src_compile || die "src_compile failed"
866  src_install || die "src_install failed"  src_install || die "src_install failed"
867    
868    
869  #compressing doc, info & man files  # compressing doc, info & man files
870  echo -e "Compressing man-pages ..."  echo -e "Compressing man-pages ..."
871  if [ -d ${BUILDDIR}/builded/usr/share/man ]  if [ -d ${BUILDDIR}/builded/usr/share/man ]
872  then  then
# Line 422  then Line 879  then
879   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info
880  fi  fi
881    
882  #the new buildpkg command  # stripping all bins and libs
883    case ${NOSTRIP} in
884     true|TRUE|yes|y)
885     echo -e "NOSTRIP=true detected; Package will not be stripped ..."
886     ;;
887     *)
888     echo -e "Stripping binaries ..."
889     mstripbins ${BINDIR}
890     echo -e "Stripping libraries ..."
891     mstriplibs ${BINDIR}
892     ;;
893    esac
894    
895    # the new buildpkg command
896  case ${NOPKGBUILD} in  case ${NOPKGBUILD} in
897   true|TRUE|yes|y)   true|TRUE|yes|y)
898   echo -e "NOPGKBUILD=true detected; Package will not be build ..."   echo -e "NOPGKBUILD=true detected; Package will not be build ..."
899   ;;   ;;
900   *)   *)
901   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   # build serveral targets
902   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   if [ -n "${MAGE_TARGETS}" ]
903     then
904     for target in ${MAGE_TARGETS}
905     do
906     # check if an special target_pkgbuild exists
907     if typeset -f ${target}_pkgbuild > /dev/null
908     then
909     # run it
910     ${target}_pkgbuild
911     fi
912     # now create the target package
913     ${MLIBDIR}/pkgbuild_dir.sh \
914     "${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD}" \
915     ${BINDIR} || die "target: ${target} package-build failed"
916     echo -e "\nPackage ${PNAME}-${target}-${PVER}-${CHOST%%-*}-${PBUILD} successfully builded.\n"
917     done
918     else
919     ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
920     echo -e "\nPackage ${PKGNAME} successfully builded.\n"
921     fi
922   ;;   ;;
923  esac  esac
924    
925  #for sure  # for sure
926  unset NOPKGBUILD  unset NOPKGBUILD
927    unset NOSTRIP
928    
929  xtitleclean  xtitleclean
930  #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  #echo -e "\nPackage ${PKGNAME} successfully builded.\n"

Legend:
Removed from v.33  
changed lines
  Added in v.194